(*################################################################################*)
(*# Snake  v1.0  (c) 2002 Christian Flmig                                       #*)
(*#                                                                         #*)
(*#   http://www.my-heaven.de                                                    #*)
(*#   Mail: christian.flaemig@my-heaven.de                                       #*)
(*#                                                                              #*)
(*# Bentigt im selben Verzeichnis die Module                                    #*)
(*#        *Zufall (von Michael Khn auf http://www.mksoftware.de.vu)            #*)
(*#        *WinDef                                                               #*)
(*#        *WinUser                                                              #*)
(*#        *WinBase                                                              #*)
(*#                                                                              #*)
(*# Der Benutzer des Modules 'Snake' muss Schreibrechte im System/Verzeichnis    #*)
(*# besitzen.                                                                    #*)
(*#                                                                              #*)
(*# Kompilierung von 'Snake' nur unter Windows mit installiertem Pow!(r) v3.0    #*)
(*# mglich.                                                                     #*)
(*#                                                                              #*)
(*# Anregeungen bitte an:                                                        #*)
(*#         snake@my-heaven.de                                                   #*)
(*#                                                                              #*)
(*#                                                                              #*)
(*################################################################################*)
(*################################################################################*)
(*#*)                                                                          (*#*)
(*#*)MODULE Snake;                                                             (*#*)
(*#*)                                                                          (*#*)
(*#*)IMPORT C:=ColorPlane, Float,Utils,Strings,Zufall,WinDef,WinUser,WinBase;  (*#*)
(*#*)                                                                          (*#*)
(*################################################################################*)
(*################################################################################*)
(*#*)                                                                          (*#*)
(*#*)TYPE                                                                      (*#*)
(*#*)                                                                          (*#*)
(*#*)handle*=WinDef.HANDLE;                                                    (*#*)
(*#*)RetCodeT*=INTEGER;                                                        (*#*)
(*#*)                                                                          (*#*)
(*#*)kopf1 = RECORD                    (*Kopf der Schlange1*)                  (*#*)
(*#*)          aktX,                                                           (*#*)
(*#*)          aktY,                                                           (*#*)
(*#*)          winkel,winkelNeu:REAL                                           (*#*)
(*#*)         END;                                                             (*#*)
(*#*)kopf2 = RECORD                    (*Kopf der Schlange2*)                  (*#*)
(*#*)          aktX,                                                           (*#*)
(*#*)          aktY,                                                           (*#*)
(*#*)          winkel,winkelNeu:REAL                                           (*#*)
(*#*)         END;                                                             (*#*)
(*#*)glied1 = RECORD                    (*ein glied der schlange1*)            (*#*)
(*#*)        X1,Y1,    X2,Y2,                                                  (*#*)
(*#*)        X3,Y3,    X4,Y4:REAL;                                             (*#*)
(*#*)        END;                                                              (*#*)
(*#*)glied2 = RECORD                    (*ein glied der schlange1*)            (*#*)
(*#*)        X1,Y1,    X2,Y2,                                                  (*#*)
(*#*)        X3,Y3,    X4,Y4:REAL;                                             (*#*)
(*#*)        END;                                                              (*#*)
(*#*)VAR                                                                       (*#*)
(*#*)    Schlange1:ARRAY 100000 OF glied1;  (*Schlange = Folge von Glied*)     (*#*)
(*#*)    Schlange2:ARRAY 100000 OF glied2;                                     (*#*)
(*#*)    Snake1:kopf1;                                                         (*#*)
(*#*)    Snake2:kopf2;                                                         (*#*)
(*#*)                                                                          (*#*)
(*################################################################################*)
(*#################################################################################*)
(*#*)                                                                           (*#*)
(*#*)PROCEDURE Anleitung;                                                       (*#*)
(*#*)BEGIN                                                                      (*#*)
(*#*)C.GotoXY(0,400);                                                           (*#*)
(*#*)C.WriteStr('                ANLEITUNG');C.WriteLn;                         (*#*)
(*#*)C.WriteStr('                ');C.WriteLn;                         (*#*)
(*#*)C.WriteStr(' Schlange zum Fressen fhren, damit sie wchst. Die Tasten  ');(*#*)
(*#*)C.WriteLn;                                                                 (*#*)
(*#*)C.WriteStr(' Cursor Up/Down und Cusror Left/Right steuern die Schlange. ');(*#*)
(*#*)C.WriteLn;                                                                 (*#*)
(*#*)C.WriteStr(' Anhalten ist mit der Taste [Enter] mglich, aufgehoben wird');(*#*)
(*#*)C.WriteLn;                                                                 (*#*)
(*#*)C.WriteStr(' sie durch eine beliebig andere Taste. Umkehren ist nicht   ');(*#*)
(*#*)C.WriteLn;                                                                 (*#*)
(*#*)C.WriteStr(' mglich. Nicht in die Wand oder den eigenen Schwanz beien!');(*#*)
(*#*)C.WriteLn;                                                                 (*#*)
(*#*)C.WriteLn; C.SetForeColor(255,0,0);                                        (*#*)
(*#*)C.WriteStr('             [Zurck zum Spiel]');C.SetForeColor(0,0,0);       (*#*)
(*#*)REPEAT UNTIL C.KeyPressed();                                               (*#*)
(*#*)C.GotoXY(0,400);                                                           (*#*)
(*#*)C.WriteStr('                         ');C.WriteLn;                         (*#*)
(*#*)C.WriteStr('                         ');C.WriteLn;                         (*#*)
(*#*)C.WriteStr('                                                            ');(*#*)
(*#*)C.WriteLn;                                                                 (*#*)
(*#*)C.WriteStr('                                                            ');(*#*)
(*#*)C.WriteLn;                                                                 (*#*)
(*#*)C.WriteStr('                                                            ');(*#*)                                       
(*#*)C.WriteLn;                                                                 (*#*)
(*#*)C.WriteStr('                                                            ');(*#*)                              
(*#*)C.WriteLn;                                                                 (*#*)
(*#*)C.WriteStr('                                                            ');(*#*)
(*#*)C.WriteLn;                                                                 (*#*)
(*#*)C.WriteLn;                                                                 (*#*)
(*#*)C.WriteStr('                                    ');C.WriteLn;              (*#*)
(*#*)END Anleitung;                                                             (*#*)
(*#*)                                                                           (*#*)
(*#################################################################################*)
(*#################################################################################*)
(*#*)                                                                           (*#*)
(*#*)PROCEDURE Vollbild();                                                      (*#*)
(*#*)VAR                                                                        (*#*)
(*#*)BEGIN                                                                      (*#*)
(*#*)                                                                           (*#*)
(*#*)IF WinUser.ShowWindow(WinUser.GetActiveWindow(),3) = 0                     (*#*)
(*#*)      THEN                                                                 (*#*)
(*#*)         C.SetForeColor(255,0,0);                                          (*#*)
(*#*)         C.GotoXY(580,40);                                                 (*#*)
(*#*)         C.WriteStr('Fehler im Modul WinUser!')                            (*#*)
(*#*)      END;                                                                 (*#*)
(*#*)END Vollbild;                                                              (*#*)
(*#*)                                                                           (*#*)
(*#################################################################################*)
(*#################################################################################*)
(*#*)                                                                           (*#*)
(*#*)PROCEDURE TerminalBell();                                                  (*#*)
(*#*)       (* A short sound is emitted. *)                                     (*#*)
(*#*)VAR                                                                        (*#*)
(*#*)  dummy:WinDef.BOOL;                                                       (*#*)
(*#*)BEGIN                                                                      (*#*)
(*#*)  dummy:=WinUser.MessageBeep(WinUser.MB_ICONEXCLAMATION);                  (*#*)
(*#*)END TerminalBell;                                                          (*#*)
(*#*)                                                                           (*#*)
(*#################################################################################*)
(*#################################################################################*)
(*#*)                                                                           (*#*)
(*#*)PROCEDURE Round(x: REAL): INTEGER;                                         (*#*)
(*#*)  BEGIN   (*Rundet Werte*)                                                 (*#*)
(*#*)    IF x >= 0                                                              (*#*)
(*#*)      THEN RETURN SHORT(ENTIER(x+0.5));                                    (*#*)
(*#*)      ELSE RETURN SHORT(-ENTIER(-x+0.5));                                  (*#*)
(*#*)  END;                                                                     (*#*)
(*#*)END Round;                                                                 (*#*)
(*#*)                                                                           (*#*)
(*#################################################################################*)
(*#################################################################################*)
(*#*)                                                                           (*#*)
(*#*)PROCEDURE Bogen(grad:REAL):REAL;                                           (*#*)
(*#*)    (* rechnet Gradzahlen in Bogenma um *)                                (*#*)
(*#*)  BEGIN                                                                    (*#*)
(*#*)    RETURN grad / 180 * SHORT(Float.Pi);                                   (*#*)
(*#*)END Bogen;                                                                 (*#*)
(*#*)                                                                           (*#*)
(*#################################################################################*)
(*#################################################################################*)
(*#*)                                                                           (*#*)
(*#*)PROCEDURE Tot1(aktX,aktY,winkel:REAL):BOOLEAN;                              (*#*)
(*#*)VAR        (*berprft,ob man tot ist*)                                    (*#*)
(*#*)  wX,wY:REAL;                                                              (*#*)
(*#*)  r,g,b:INTEGER;                                                           (*#*)
(*#*)BEGIN                                                                      (*#*)
(*#*)                                                                           (*#*)
(*#*)  wX:=Snake1.aktX  + 2.5 * Float.Cos(Bogen(Snake1.winkel)) ;                 (*#*)
(*#*)  wY:=Snake1.aktY  + 2.5 * Float.Sin(Bogen(Snake1.winkel)) ;                 (*#*)
(*#*)  C.GetDot(Round(wX),Round(wY),r,g,b);                                     (*#*)
(*#*)  IF ((r=0) & (g=0) & (b=0)) OR ((r=0) & (g=0) & (b=255)) THEN             (*#*)
(*#*)  TerminalBell();                                                          (*#*)
(*#*)  TerminalBell();                                                          (*#*)
(*#*)  TerminalBell();                                                          (*#*)
(*#*)  TerminalBell();                                                          (*#*)
(*#*)  TerminalBell();                                                          (*#*)
(*#*)  TerminalBell();                                                          (*#*)
(*#*)  TerminalBell();                                                          (*#*)
(*#*)  RETURN TRUE;                                                             (*#*)
(*#*)  ELSE RETURN FALSE;                                                       (*#*)
(*#*)  END;                                                                     (*#*)
(*#*)END Tot1;                                                                   (*#*)
(*#*)                                                                           (*#*)
(*#################################################################################*)
(*#################################################################################*)
(*#*)                                                                           (*#*)
(*#*)PROCEDURE Tot2(aktX,aktY,winkel:REAL):BOOLEAN;                              (*#*)
(*#*)VAR        (*berprft,ob man tot ist*)                                    (*#*)
(*#*)  wX,wY:REAL;                                                              (*#*)
(*#*)  r,g,b:INTEGER;                                                           (*#*)
(*#*)BEGIN                                                                      (*#*)
(*#*)                                                                           (*#*)
(*#*)  wX:=Snake2.aktX  + 2.5 * Float.Cos(Bogen(Snake2.winkel)) ;                 (*#*)
(*#*)  wY:=Snake2.aktY  + 2.5 * Float.Sin(Bogen(Snake2.winkel)) ;                 (*#*)
(*#*)  C.GetDot(Round(wX),Round(wY),r,g,b);                                     (*#*)
(*#*)  IF ((r=0) & (g=0) & (b=0)) OR ((r=0) & (g=0) & (b=255)) THEN             (*#*)
(*#*)  TerminalBell();                                                          (*#*)
(*#*)  TerminalBell();                                                          (*#*)
(*#*)  TerminalBell();                                                          (*#*)
(*#*)  TerminalBell();                                                          (*#*)
(*#*)  TerminalBell();                                                          (*#*)
(*#*)  TerminalBell();                                                          (*#*)
(*#*)  TerminalBell();                                                          (*#*)
(*#*)  RETURN TRUE;                                                             (*#*)
(*#*)  ELSE RETURN FALSE;                                                       (*#*)
(*#*)  END;                                                                     (*#*)
(*#*)END Tot2;                                                                   (*#*)
(*#*)                                                                           (*#*)
(*#################################################################################*)
(*#################################################################################*)
(*#*)                                                                           (*#*)
(*#*)PROCEDURE Spielfeld;                                                       (*#*)
(*#*)VAR     (*erzeugt einen kasten um das spielfeld*)                          (*#*)
(*#*)BEGIN                                                                      (*#*)
(*#*)  C.Line(20,20,780,20,1);                                                  (*#*)
(*#*)  C.Line(20,19,780,19,1);                                                  (*#*)
(*#*)  C.Line(20,18,780,18,1);                                                  (*#*)
(*#*)  C.Line(20,17,780,17,1);                                                  (*#*)
(*#*)                                                                           (*#*)
(*#*)  C.Line(20,500,780,500,1);                                                (*#*)
(*#*)  C.Line(20,501,780,501,1);                                                (*#*)
(*#*)  C.Line(20,502,780,502,1);                                                (*#*)
(*#*)  C.Line(20,503,780,503,1);                                                (*#*)
(*#*)                                                                           (*#*)
(*#*)  C.Line(20,17,20,503,1);                                                  (*#*)
(*#*)  C.Line(19,17,19,503,1);                                                  (*#*)
(*#*)  C.Line(18,17,18,503,1);                                                  (*#*)
(*#*)  C.Line(17,17,17,503,1);                                                  (*#*)
(*#*)                                                                           (*#*)
(*#*)  C.Line(780,17,780,503,1);                                                (*#*)
(*#*)  C.Line(781,17,781,503,1);                                                (*#*)
(*#*)  C.Line(782,17,782,503,1);                                                (*#*)
(*#*)  C.Line(783,17,783,503,1);                                                (*#*)
(*#*)END Spielfeld;                                                             (*#*)
(*#*)                                                                           (*#*)
(*#################################################################################*)
(*#################################################################################*)
(*#*)                                                                           (*#*)
(*#*)PROCEDURE StreckenVorgabe1(aktX,aktY:REAL;VAR neuX,neuY:REAL);              (*#*)
(*#*)VAR       (*gibt die neue strecke vor*)                                    (*#*)
(*#*)BEGIN                                                                      (*#*)
(*#*)  neuX := Snake1.aktX + 1 * Float.Cos(Bogen(Snake1.winkel));                 (*#*)
(*#*)  neuY := Snake1.aktY + 1 * Float.Sin(Bogen(Snake1.winkel));                 (*#*)
(*#*)END StreckenVorgabe1;                                                       (*#*)
(*#*)                                                                           (*#*)
(*#################################################################################*)
(*#################################################################################*)
(*#*)                                                                           (*#*)
(*#*)PROCEDURE StreckenVorgabe2(aktX,aktY:REAL;VAR neuX,neuY:REAL);              (*#*)
(*#*)VAR       (*gibt die neue strecke vor*)                                    (*#*)
(*#*)BEGIN                                                                      (*#*)
(*#*)  neuX := Snake2.aktX + 1 * Float.Cos(Bogen(Snake2.winkel));                 (*#*)
(*#*)  neuY := Snake2.aktY + 1 * Float.Sin(Bogen(Snake2.winkel));                 (*#*)
(*#*)END StreckenVorgabe2;                                                       (*#*)
(*#*)                                                                           (*#*)
(*#################################################################################*)
(*#################################################################################*)
(*#*)                                                                           (*#*)
(*#*)PROCEDURE Zeichnen1(aktX1,aktY1,neuX1,neuY1:REAL;winkel:REAL);                  (*#*)
(*#*)VAR    (*Zeichnet Schlangenglied*)                                         (*#*)
(*#*)BEGIN                                                                      (*#*)
(*#*)  Snake1.aktX:=aktX1;                                                        (*#*)
(*#*)  Snake1.aktY:=aktY1;                                                        (*#*)
(*#*)                                                                           (*#*)
(*#*)  C.SetForeColor(0,0,255);                                                 (*#*)
(*#*)  IF (winkel=180) OR (winkel=0) OR (winkel=360) THEN                       (*#*)
(*#*)C.Line(Round(Snake1.aktX),Round(Snake1.aktY+0),Round(neuX1),Round(neuY1+0),1); (*#*)
(*#*)C.Line(Round(Snake1.aktX),Round(Snake1.aktY+1),Round(neuX1),Round(neuY1+1),1); (*#*)
(*#*)C.Line(Round(Snake1.aktX),Round(Snake1.aktY-1),Round(neuX1),Round(neuY1+1),1); (*#*)
(*#*)C.Line(Round(Snake1.aktX),Round(Snake1.aktY+2),Round(neuX1),Round(neuY1+2),1); (*#*)
(*#*)C.Line(Round(Snake1.aktX),Round(Snake1.aktY-2),Round(neuX1),Round(neuY1+2),1); (*#*)
(*#*)  ELSIF (winkel=90) OR (winkel=270) THEN                                   (*#*)
(*#*)C.Line(Round(Snake1.aktX+2),Round(Snake1.aktY),Round(neuX1+2),Round(neuY1),1); (*#*)
(*#*)C.Line(Round(Snake1.aktX+1),Round(Snake1.aktY),Round(neuX1+1),Round(neuY1),1); (*#*)
(*#*)C.Line(Round(Snake1.aktX+0),Round(Snake1.aktY),Round(neuX1+0),Round(neuY1),1); (*#*)
(*#*)C.Line(Round(Snake1.aktX-1),Round(Snake1.aktY),Round(neuX1-1),Round(neuY1),1); (*#*)
(*#*)C.Line(Round(Snake1.aktX-2),Round(Snake1.aktY),Round(neuX1-2),Round(neuY1),1); (*#*)
(*#*)  END;                                                                     (*#*)
(*#*)  C.SetForeColor(0,0,0);                                                   (*#*)
(*#*)                                                                           (*#*)
(*#*)END Zeichnen1;                                                              (*#*)
(*#*)                                                                           (*#*)
(*#################################################################################*)
(*#################################################################################*)
(*#*)                                                                           (*#*)
(*#*)PROCEDURE Zeichnen2(aktX2,aktY2,neuX2,neuY2:REAL;winkel:REAL);                  (*#*)
(*#*)VAR    (*Zeichnet Schlangenglied*)                                         (*#*)
(*#*)BEGIN                                                                      (*#*)
(*#*)  Snake2.aktX:=aktX2;                                                        (*#*)
(*#*)  Snake2.aktY:=aktY2;                                                        (*#*)
(*#*)                                                                           (*#*)
(*#*)  C.SetForeColor(0,0,255);                                                 (*#*)
(*#*)  IF (winkel=180) OR (winkel=0) OR (winkel=360) THEN                       (*#*)
(*#*)C.Line(Round(Snake2.aktX),Round(Snake2.aktY+0),Round(neuX2),Round(neuY2+0),1); (*#*)
(*#*)C.Line(Round(Snake2.aktX),Round(Snake2.aktY+1),Round(neuX2),Round(neuY2+1),1); (*#*)
(*#*)C.Line(Round(Snake2.aktX),Round(Snake2.aktY-1),Round(neuX2),Round(neuY2+1),1); (*#*)
(*#*)C.Line(Round(Snake2.aktX),Round(Snake2.aktY+2),Round(neuX2),Round(neuY2+2),1); (*#*)
(*#*)C.Line(Round(Snake2.aktX),Round(Snake2.aktY-2),Round(neuX2),Round(neuY2+2),1); (*#*)
(*#*)  ELSIF (winkel=90) OR (winkel=270) THEN                                   (*#*)
(*#*)C.Line(Round(Snake2.aktX+2),Round(Snake2.aktY),Round(neuX2+2),Round(neuY2),1); (*#*)
(*#*)C.Line(Round(Snake2.aktX+1),Round(Snake2.aktY),Round(neuX2+1),Round(neuY2),1); (*#*)
(*#*)C.Line(Round(Snake2.aktX+0),Round(Snake2.aktY),Round(neuX2+0),Round(neuY2),1); (*#*)
(*#*)C.Line(Round(Snake2.aktX-1),Round(Snake2.aktY),Round(neuX2-1),Round(neuY2),1); (*#*)
(*#*)C.Line(Round(Snake2.aktX-2),Round(Snake2.aktY),Round(neuX2-2),Round(neuY2),1); (*#*)
(*#*)  END;                                                                     (*#*)
(*#*)  C.SetForeColor(0,0,0);                                                   (*#*)
(*#*)                                                                           (*#*)
(*#*)END Zeichnen2;                                                              (*#*)
(*#*)                                                                           (*#*)
(*#################################################################################*)
(*#################################################################################*)
(*#*)                                                                           (*#*)
(*#*)PROCEDURE Speichern1(laenge:LONGINT; aktX,aktY:REAL);                       (*#*)
(*#*)VAR      (*Speichert die Position der Schlange*)                           (*#*)
(*#*)BEGIN                                                                      (*#*)
(*#*)  Snake1.aktX:=aktX;                                                        (*#*)
(*#*)  Snake1.aktY:=aktY;                                                        (*#*)
(*#*)  Schlange1[laenge].X1:=(Snake1.aktX);                                       (*#*)
(*#*)  Schlange1[laenge].Y1:=(Snake1.aktY);                                       (*#*)
(*#*)  Schlange1[laenge].X2:=(Snake1.aktX+1);                                     (*#*)
(*#*)  Schlange1[laenge].Y2:=(Snake1.aktY);                                       (*#*)
(*#*)  Schlange1[laenge].X3:=(Snake1.aktX);                                       (*#*)
(*#*)  Schlange1[laenge].Y3:=(Snake1.aktY+1);                                     (*#*)
(*#*)  Schlange1[laenge].X4:=(Snake1.aktX+1);                                     (*#*)
(*#*)  Schlange1[laenge].Y4:=(Snake1.aktY+1);                                     (*#*)
(*#*)                                                                           (*#*)
(*#*)END Speichern1;                                                             (*#*)
(*#*)                                                                           (*#*)
(*#################################################################################*)
(*#################################################################################*)
(*#*)                                                                           (*#*)
(*#*)PROCEDURE Speichern2(laenge:LONGINT; aktX,aktY:REAL);                       (*#*)
(*#*)VAR      (*Speichert die Position der Schlange*)                           (*#*)
(*#*)BEGIN                                                                      (*#*)
(*#*)  Snake2.aktX:=aktX;                                                        (*#*)
(*#*)  Snake2.aktY:=aktY;                                                        (*#*)
(*#*)  Schlange2[laenge].X1:=(Snake2.aktX);                                       (*#*)
(*#*)  Schlange2[laenge].Y1:=(Snake2.aktY);                                       (*#*)
(*#*)  Schlange2[laenge].X2:=(Snake2.aktX+1);                                     (*#*)
(*#*)  Schlange2[laenge].Y2:=(Snake2.aktY);                                       (*#*)
(*#*)  Schlange2[laenge].X3:=(Snake2.aktX);                                       (*#*)
(*#*)  Schlange2[laenge].Y3:=(Snake2.aktY+1);                                     (*#*)
(*#*)  Schlange2[laenge].X4:=(Snake2.aktX+1);                                     (*#*)
(*#*)  Schlange2[laenge].Y4:=(Snake2.aktY+1);                                     (*#*)
(*#*)                                                                           (*#*)
(*#*)END Speichern2;                                                             (*#*)
(*#*)                                                                           (*#*)
(*#################################################################################*)
(*#################################################################################*)
(*#*)                                                                           (*#*)
(*#*)PROCEDURE Schwanzende1(laenge1,zaehler1,wahre_laenge1:LONGINT);                (*#*)
(*#*)VAR      (*zeichnet das schwanzende*)                                      (*#*)
(*#*)    dot1X,dot1Y,                                                           (*#*)
(*#*)    dot2X,dot2Y,                                                           (*#*)
(*#*)    dot3X,dot3Y,                                                           (*#*)
(*#*)    dot4X,dot4Y:REAL;                                                      (*#*)
(*#*)BEGIN                                                                      (*#*)
(*#*)  dot1X:=Schlange1[laenge1-zaehler1].X1; dot1Y:=Schlange1[laenge1-zaehler1].Y1;  (*#*)
(*#*)  dot2X:=Schlange1[laenge1-zaehler1].X2; dot2Y:=Schlange1[laenge1-zaehler1].Y2;  (*#*)
(*#*)  dot3X:=Schlange1[laenge1-zaehler1].X3; dot3Y:=Schlange1[laenge1-zaehler1].Y3;  (*#*)
(*#*)  dot4X:=Schlange1[laenge1-zaehler1].X4; dot4Y:=Schlange1[laenge1-zaehler1].Y4;  (*#*)
(*#*)                                                                           (*#*)
(*#*)  IF zaehler1>=wahre_laenge1 THEN                                            (*#*)
(*#*)  C.Box(Round(dot1X)-3,Round(dot1Y)+3,Round(dot4X)+3,Round(dot4Y)-3,2);    (*#*)
(*#*)  ELSE                                                                     (*#*)
(*#*)  END;                                                                     (*#*)
(*#*)END Schwanzende1;                                                           (*#*)
(*#*)                                                                           (*#*)
(*#################################################################################*)
(*#################################################################################*)
(*#*)                                                                           (*#*)
(*#*)PROCEDURE Schwanzende2(laenge2,zaehler2,wahre_laenge2:LONGINT);                (*#*)
(*#*)VAR      (*zeichnet das schwanzende*)                                      (*#*)
(*#*)    dot1X,dot1Y,                                                           (*#*)
(*#*)    dot2X,dot2Y,                                                           (*#*)
(*#*)    dot3X,dot3Y,                                                           (*#*)
(*#*)    dot4X,dot4Y:REAL;                                                      (*#*)
(*#*)BEGIN                                                                      (*#*)
(*#*)  dot1X:=Schlange2[laenge2-zaehler2].X1; dot1Y:=Schlange2[laenge2-zaehler2].Y1;  (*#*)
(*#*)  dot2X:=Schlange2[laenge2-zaehler2].X2; dot2Y:=Schlange2[laenge2-zaehler2].Y2;  (*#*)
(*#*)  dot3X:=Schlange2[laenge2-zaehler2].X3; dot3Y:=Schlange2[laenge2-zaehler2].Y3;  (*#*)
(*#*)  dot4X:=Schlange2[laenge2-zaehler2].X4; dot4Y:=Schlange2[laenge2-zaehler2].Y4;  (*#*)
(*#*)                                                                           (*#*)
(*#*)  IF zaehler2>=wahre_laenge2 THEN                                            (*#*)
(*#*)  C.Box(Round(dot1X)-3,Round(dot1Y)+3,Round(dot4X)+3,Round(dot4Y)-3,2);    (*#*)
(*#*)  ELSE                                                                     (*#*)
(*#*)  END;                                                                     (*#*)
(*#*)END Schwanzende2;                                                           (*#*)
(*#*)                                                                           (*#*)
(*#################################################################################*)
(*#################################################################################*)
(*#*)                                                                           (*#*)
(*#*)PROCEDURE GeschwindigkeitsBremse(x:SHORTINT);                              (*#*)
(*#*)VAR    (*Bremst den Programmablauf*)                                       (*#*)
(*#*)  i1,i,start,y:LONGINT;                                                    (*#*)
(*#*)  q:REAL;                                                                  (*#*)
(*#*)BEGIN                                                                      (*#*)
(*#*) CASE x OF                                                                 (*#*)
(*#*)    12:y:=10000;                                                           (*#*)
(*#*)   |5 :y:=5000;                                                            (*#*)
(*#*)   |2 :y:=2000;                                                            (*#*)
(*#*)   END;                                                                    (*#*)
(*#*)   FOR i:=1 TO y DO                                                        (*#*)
(*#*)     q:=Float.Sqrt(9);                                                     (*#*)
(*#*)   END;                                                                    (*#*)
(*#*)END GeschwindigkeitsBremse;                                                (*#*)
(*#*)                                                                           (*#*)
(*#################################################################################*)
(*#################################################################################*)
(*#*)                                                                           (*#*)
(*#*)PROCEDURE Punkte_add(menu_set_V:SHORTINT):REAL;                            (*#*)
(*#*)VAR       (*berechnet die punkte, fr das geschluckte ziel*)               (*#*)
(*#*)  faktor:REAL;                                                             (*#*)
(*#*)BEGIN                                                                      (*#*)
(*#*)                                                                           (*#*)
(*#*)  CASE menu_set_V OF                                                       (*#*)
(*#*)    1:faktor:=0.5;                                                         (*#*)
(*#*)   |2:faktor:=1;                                                           (*#*)
(*#*)   |3:faktor:=1.5                                                          (*#*)
(*#*)  END;                                                                     (*#*)
(*#*)                                                                           (*#*)
(*#*)  RETURN (10*faktor);                                                      (*#*)
(*#*)                                                                           (*#*)
(*#*)END Punkte_add;                                                            (*#*)
(*#*)                                                                           (*#*)
(*#################################################################################*)
(*#################################################################################*)
(*#*)                                                                           (*#*)
(*#*)PROCEDURE print_punkte(punkte1,punkte2:REAL);                              (*#*)
(*#*)VAR      (*gibt die punkte aus*)                                           (*#*)
(*#*)                                                                           (*#*)
(*#*)  PunkteTXT1,PunkteTXT2:ARRAY 50 OF CHAR;                                              (*#*)
(*#*)BEGIN                                                                      (*#*)
(*#*)  C.GotoXY(0,550);                                                         (*#*)
(*#*)                                                                           (*#*)
(*#*)  Float.StrF(punkte1,6,0,PunkteTXT1);                                        (*#*)
(*#*)  C.WriteStr('Player 1:');C.WriteStr(PunkteTXT2);                             (*#*)
(*#*)  
       C.GotoXY(500,550);                                                         (*#*)
(*#*)                                                                           (*#*)
(*#*)  Float.StrF(punkte2,6,0,PunkteTXT2);                                        (*#*)
(*#*)  C.WriteStr('Player 2: ');C.WriteStr(PunkteTXT2);                                                                  (*#*)
(*#*)END print_punkte;                                                          (*#*)
(*#*)                                                                           (*#*)
(*#################################################################################*)
(*#################################################################################*)

PROCEDURE ProgMain*;
VAR 
 
  zaehler1,wahre_laenge1,laenge1,
  zaehler2,wahre_laenge2,laenge2,
  tempz_x,tempz_y:LONGINT;

  
  geschwindigkeit,menu_set_V,winkel:SHORTINT;
  
  neuX1,neuY1,neuX2,neuY2,wX,wY,punkte1,punkte2,faktor,punkte_neu1,punkte_neu2,punkte_add1,punkte_add2,z_x,z_y:REAL;
  
  r,g,b,zaehl_fressen,dotX,dotY,i,I:INTEGER;
  
  multi,tot1,tot2,box,neue_box,fressen,gefressen,ende:BOOLEAN;
  
  taste1,taste2,menu,einerTXT:CHAR;
  
  PunkteTXT,geschwindigkeitTXT:ARRAY 50 OF CHAR;
  
  t,score,einerARRAY:ARRAY 10 OF CHAR;
  
  fHandle:handle;
  
  error:RetCodeT;
  

  
BEGIN
C.Open;(*initaliesierung*)

(*Nullstezten aller Variablen*)
  Vollbild;
  einerARRAY:='2';
  menu_set_V:=2;
  geschwindigkeit:=5;
  
  punkte_add1:=0;
  punkte_add2:=0;
  




(*Beginn der Programmschleife*)

LOOP
  C.Clear();

  Snake1.aktX   :=50;
  Snake1.aktY   :=50;
  Snake1.winkel := 0;
  Snake1.winkelNeu:=0;
  
  Snake2.aktX   :=700;
  Snake2.aktY   :=450;
  Snake2.winkel := 0;
  Snake2.winkelNeu:=0;
  
  C.SetScreenUpdate(TRUE);
  
  tot1:=FALSE;
  tot2:=FALSE;
  
  zaehler1:=1;
  laenge1:=1;
  wahre_laenge1:=300;
  
  zaehler2:=1;
  laenge2:=1;
  wahre_laenge2:=300;
   
  neue_box:=TRUE;
  punkte1:=0;
  punkte2:=0;
  
  multi:=TRUE;
  

  
  (*Men zeichnen*)
  C.GotoXY(250,650);
  C.WriteStr('Snake by Karotte');C.WriteLn;
  C.GotoXY(250,630);
  C.WriteStr('');C.WriteLn;C.WriteLn;
  C.WriteStr('Geschwindigkeit:[F1] akt: ');C.WriteStr(einerARRAY);C.WriteLn;
  C.WriteStr('Anleitung: [F2]');C.WriteLn;
  C.WriteStr('Start: [ENTER]');C.WriteLn;
  C.WriteStr('Beenden: [ESC]');C.WriteLn;
  
  (*Mentasten lesen*)
  LOOP
  menu:=C.ReadKey();

  (*nach tasten unterscheiden*)
  CASE menu OF
   C.F1: 
       (*geschwindigkeit setzen*)
       REPEAT
           C.GotoXY(250,590);
           C.WriteStr('[1/2/3]: ');
           einerTXT:=C.ReadKey();

               CASE einerTXT OF
                '1':menu_set_V:=1;
               |'2':menu_set_V:=2;
               |'3':menu_set_V:=3;
               ELSE  
               END;
       UNTIL (menu_set_V=1) OR (menu_set_V=2) OR (menu_set_V=3);
       
       Strings.Str(menu_set_V,einerARRAY);
       C.WriteStr(einerARRAY);
       C.GotoXY(0,590);
       C.WriteStr('Geschwindigkeit:[F1] akt: ');C.WriteStr(einerARRAY);C.WriteStr('                   ');
           
           CASE menu_set_V OF
             1:geschwindigkeit:=12;
            |2:geschwindigkeit:=5;
            |3:geschwindigkeit:=2;
           END;
  (*Anleitung*)         
  |C.F2:Anleitung;
  (*spiel beenden*) 
  |C.ESC: ende:=TRUE;    EXIT ;
  (*Spiel starten*)
  |C.ENTER: 
  
  EXIT;
  ELSE
  END;
  
  END;
  
  (*men aktualisieren*) 
  C.GotoXY(250,650);
  C.WriteStr('Snake by Karotte');C.WriteLn;
  C.GotoXY(250,630);
  C.WriteStr('');C.WriteLn;C.WriteLn;
  C.WriteStr('Geschwindigkeit:[F1] akt: ');C.WriteStr(einerARRAY);C.WriteLn;
  C.WriteStr('Pause: [ENTER] ');C.WriteLn;
  C.WriteStr('                    ');C.WriteLn;
  C.WriteStr('                    ');
  
  (*Progarmm beenden*)
  IF ende=TRUE THEN EXIT END;
  
  Spielfeld;
  
  REPEAT UNTIL C.KeyPressed();



LOOP (*hier beginnt das eigentliche Spiel*)
  

  
  (*Procedure Spielfeld wird aufgerufen*)
  Spielfeld;
  
  taste1:=C.F2;
  taste2:=C.F2;  

  
  (*Procedure Geschwindigkeits bremse wird aufgerufen, und die gewhlte geschwindigkeit bergeben*)
  GeschwindigkeitsBremse(geschwindigkeit);

  
  (*Es wird die Funktion 'tot' aufgerufen, die ber prft, ob man tot ist;
   wenn man tot ist gibt sie 'true' zurck, ansonsten 'False'*)



(*###################Schlange1##################################*)
 tot1:=Tot1(Snake1.aktX,Snake1.aktY,Snake1.winkel); 
(*###################Schlange1##################################*)

 


  IF multi=TRUE THEN
(*###################Schlange2##################################*)  
 tot2:=Tot2(Snake2.aktX,Snake2.aktY,Snake2.winkel);
(*###################Schlange2##################################*)
  ELSE END;
 




(*###################Tasten##################################*)
 (*berprfung ob eine tatse gedrckt wurde, z.B. fr eine richtungsnderung der Schlange oder 
  geschwindigkeitsnderung des Spiels*)
  IF C.KeyPressed() THEN taste1:=C.ReadKey(); 
  
    CASE taste1 OF (*Unterscheidung der Tasten*)
      C.CURSDOWN: Snake1.winkelNeu:=270;
     |C.CURSUP:   Snake1.winkelNeu:=90;  (*winkel der schlange werden verndert*)
     |C.CURSLEFT: Snake1.winkelNeu:=180;
     |C.CURSRIGHT:Snake1.winkelNeu:=0;
     |'w':        Snake2.winkelNeu:=90;
     |'a':        Snake2.winkelNeu:=180;
     |'s':        Snake2.winkelNeu:=270;
     |'d':        Snake2.winkelNeu:=0;
     |C.ENTER:    (*pause*)
              
                 C.GotoXY(260,550);
                 C.WriteStr('Pause'); 
                 LOOP
                 IF C.KeyPressed() THEN 
                 
                 C.GotoXY(260,550);
                 C.WriteStr('     '); EXIT END;END; (*Solange, bis wieder eine taste AU?ER enter gedrckt wird*)
     |C.F1:
            (*hier wird die geschwindigkeit im Spiel nochmal gendert*)
             REPEAT
               C.GotoXY(250,590);
               C.WriteStr('[1/2/3]: ');
               einerTXT:=C.ReadKey();

               CASE einerTXT OF
                   '1':menu_set_V:=1;
                   |'2':menu_set_V:=2;
                   |'3':menu_set_V:=3;
               ELSE  
               END;
             UNTIL (menu_set_V=1) OR (menu_set_V=2) OR (menu_set_V=3);
           
           Strings.Str(menu_set_V,einerARRAY);
           C.WriteStr(einerARRAY);
           C.GotoXY(0,590);
           C.WriteStr('Geschwindigkeit:[F1] akt: ');C.WriteStr(einerARRAY);C.WriteStr('                   ');
           
           CASE menu_set_V OF
             1:geschwindigkeit:=12;
            |2:geschwindigkeit:=5;
            |3:geschwindigkeit:=2;
           END;
    ELSE END;
  END;      
    taste1:=C.F2;          
   (*Ende der tasten berprfung*)

(*###################Tasten##################################*)









(*###################Schlange1##################################*)  
IF Snake1.winkel=(Snake1.winkelNeu+180) THEN EXIT END; (*berprfung, ob der neue winkel nicht dazu frht, das man sih selbst beit;
                                                         wenn man sich beit heit es 'game over', man wird aus der spielschleif geworfen*)
(*###################Schlange1##################################*)




    IF multi=TRUE THEN
(*###################Schlange2##################################*)
IF Snake2.winkel=(Snake2.winkelNeu+180) THEN EXIT END; (*berprfung, ob der neue winkel nicht dazu frht, das man sih selbst beit;
                                                         wenn man sich beit heit es 'game over', man wird aus der spielschleif geworfen*)
(*###################Schlange2##################################*)
     ELSE END;



(*###################Schlange1##################################*)  
Snake1.winkel:=Snake1.winkelNeu; (*der neue winkel wird in das schlangen-record geschrieben, ntig fr weitere proceduren*)
(*###################Schlange1##################################*)    



      IF multi=TRUE THEN
(*###################Schlange2##################################*)
 Snake2.winkel:=Snake2.winkelNeu;  (*der neue winkel wird in das schlangen-record geschrieben, ntig fr weitere proceduren*)
(*###################Schlange2##################################*)
      ELSE END;




(*###################Schlange1##################################*)
StreckenVorgabe1(Snake1.aktX,Snake1.aktY,neuX1,neuY1); (*die neue strecke wird berechnet; aktuelle punkte rein, neue punkte raus*)
(*###################Schlange1##################################*)



        IF multi=TRUE THEN
(*###################Schlange2##################################*)
StreckenVorgabe2(Snake2.aktX,Snake2.aktY,neuX2,neuY2);(*die neue strecke wird berechnet; aktuelle punkte rein, neue punkte raus*)
(*###################Schlange2##################################*)
        ELSE END;



(*###################Schlange1##################################*)
INC(laenge1);INC(zaehler1);
(*###################Schlange1##################################*)



          IF multi=TRUE THEN
(*###################Schlange2##################################*)
  INC(laenge2);INC(zaehler2);
(*###################Schlange2##################################*)
          ELSE END;



(*###################Schlange1##################################*)
  IF zaehler1>=(wahre_laenge1+1) THEN
      zaehler1:=wahre_laenge1;   (*... und fr den fall, das er die wahre(sichtbare) lnge bersteigt zurck gerufen*)
  END;                               (*Anmerkung: die wahre lnge wchst mit dem fressen der Quadrate*)

(*###################Schlange1##################################*)



             IF multi=TRUE THEN
(*###################Schlange2##################################*)
  IF zaehler2>=(wahre_laenge2+1) THEN
      zaehler2:=wahre_laenge2;   (*... und fr den fall, das er die wahre(sichtbare) lnge bersteigt zurck gerufen*)
  END;                               (*Anmerkung: die wahre lnge wchst mit dem fressen der Quadrate*)

(*###################Schlange2##################################*)
              ELSE END;



(*###################Schlange1##################################*)
  (*die schlabge wird aufgrund der alten koordianten, der neu berechneten und dem (richtungs-)winkel gezeichnet*)
Zeichnen1(Snake1.aktX,Snake1.aktY,neuX1,neuY1,Snake1.winkelNeu); 
(*###################Schlange1##################################*)



               IF multi=TRUE THEN
(*###################Schlange2##################################*)
  (*die schlabge wird aufgrund der alten koordianten, der neu berechneten und dem (richtungs-)winkel gezeichnet*)
Zeichnen2(Snake2.aktX,Snake2.aktY,neuX2,neuY2,Snake2.winkelNeu);
(*###################Schlange2##################################*) 
              ELSE END;



(*###################Schlange1##################################*)
  (*Die position der des neusten glieds der schlange wird im schlangen record gespeichert*)
Speichern1(laenge1,Snake1.aktX,Snake1.aktY);
(*###################Schlange1##################################*)



                IF multi=TRUE THEN
(*###################Schlange2##################################*)
  (*Die position der des neusten glieds der schlange wird im schlangen record gespeichert*)
Speichern2(laenge2,Snake2.aktX,Snake2.aktY);
(*###################Schlange2##################################*)
                ELSE END;

  
(*###################Schlange1##################################*)
  (*das schwanzende wird aufgrund der wahren lnge gezeichnet, heit:
    ein weien quadrat wird hinter der schlange hergezogen, wie ein schwamm, der die schlange wieder aufsaugt*)
Schwanzende1(laenge1,zaehler1,wahre_laenge1);
(*###################Schlange1##################################*)



                    IF multi=TRUE THEN
(*###################Schlange2##################################*)
  (*das schwanzende wird aufgrund der wahren lnge gezeichnet, heit:
    ein weien quadrat wird hinter der schlange hergezogen, wie ein schwamm, der die schlange wieder aufsaugt*)
Schwanzende2(laenge2,zaehler2,wahre_laenge2);
(*###################Schlange2##################################*)
                 ELSE END;
  

  IF (neue_box=TRUE) THEN   (*ein futterquadrat wird gezeichnet*)
  
  C.SetForeColor(255,0,0);
  LOOP
  z_x:=(Zufall.RandomInt(730)+30);
  z_y:=(Zufall.RandomInt(465)+30);
  dotX:=Round(z_x);
  dotY:=Round(z_y);                                 
  C.GetDot(dotX,dotY,r,g,b);
  IF (r=255) & (g=255) & (b=255) THEN EXIT END
  END;
  
  (*malt nun den punkt*)
  
  C.Box(Round(z_x),Round(z_y),Round(z_x)+5,Round(z_y)+5,1);
  C.Box(Round(z_x)+1,Round(z_y)+1,Round(z_x)+4,Round(z_y)+4,1);
  C.Box(Round(z_x)+2,Round(z_y)+2,Round(z_x)+3,Round(z_y)+3,1);
  C.Box(Round(z_x)-1,Round(z_y-1),Round(z_x)+6,Round(z_y)+6,1);
  C.Box(Round(z_x)-2,Round(z_y-2),Round(z_x)+7,Round(z_y)+7,1);
  C.SetForeColor(0,0,0);
  neue_box:=FALSE;
  
  ELSE
  END;



(*###################Schlange1##################################*)

  IF (*berprft, ob der kopf der schlange auf ein futter-quadrat trifft*)
      (
      (Round(Snake1.aktX  + 1 * Float.Cos(Bogen(Snake1.winkel))) >= Round(z_x)-3)
      &
      (Round(Snake1.aktX  + 1 * Float.Cos(Bogen(Snake1.winkel))) <= Round(z_x)+8) 
      &
      (Round(Snake1.aktY  + 1 * Float.Cos(Bogen(Snake1.winkel)))>=Round(z_y)-3)
      & 
      (Round(Snake1.aktY  + 1 * Float.Cos(Bogen(Snake1.winkel)))<=Round(z_y)+8)
      )
      OR
      (
      (Round(Snake1.aktX+2  + 1 * Float.Cos(Bogen(Snake1.winkel))) >= Round(z_x)-3)
      &
      (Round(Snake1.aktX+2  + 1 * Float.Cos(Bogen(Snake1.winkel))) <= Round(z_x)+8) 
      &           
      (Round(Snake1.aktY+2  + 1 * Float.Cos(Bogen(Snake1.winkel)))>=Round(z_y)-3)
      & 
      (Round(Snake1.aktY+2  + 1 * Float.Cos(Bogen(Snake1.winkel)))<=Round(z_y)+8)
      )
      OR
      (
      (Round(Snake1.aktX-2  + 1 * Float.Cos(Bogen(Snake1.winkel))) >= Round(z_x)-3)
      &
      (Round(Snake1.aktX-2  + 1 * Float.Cos(Bogen(Snake1.winkel))) <= Round(z_x)+8) 
      &
      (Round(Snake1.aktY-2  + 1 * Float.Cos(Bogen(Snake1.winkel)))>=Round(z_y)-3)
      & 
      (Round(Snake1.aktY-2  + 1 * Float.Cos(Bogen(Snake1.winkel)))<=Round(z_y)+8)
      )
  THEN
      (*wenn ja, dann wird es 'gefressen'*)
      neue_box:=TRUE;
      INC(wahre_laenge1,25);

      C.SetForeColor(255,255,255);
      C.Box(Round(z_x),Round(z_y),Round(z_x)+5,Round(z_y)+5,1);
      C.Box(Round(z_x)+1,Round(z_y)+1,Round(z_x)+4,Round(z_y)+4,1);
      C.Box(Round(z_x)+2,Round(z_y)+2,Round(z_x)+3,Round(z_y)+3,1);
      C.Box(Round(z_x)-1,Round(z_y-1),Round(z_x)+6,Round(z_y)+6,1);
      C.Box(Round(z_x)-2,Round(z_y-2),Round(z_x)+7,Round(z_y)+7,1);
      C.SetForeColor(0,0,0);
      TerminalBell();TerminalBell();
      punkte_add1:=Punkte_add(menu_set_V);
  ELSE 
      (*ansonsten nicht*)
      neue_box:=FALSE;
      C.SetForeColor(255,0,0);
      C.Box(Round(z_x),Round(z_y),Round(z_x)+5,Round(z_y)+5,1);
      C.Box(Round(z_x)+1,Round(z_y)+1,Round(z_x)+4,Round(z_y)+4,1);
      C.Box(Round(z_x)+2,Round(z_y)+2,Round(z_x)+3,Round(z_y)+3,1);
      C.Box(Round(z_x)-1,Round(z_y-1),Round(z_x)+6,Round(z_y)+6,1);
      C.Box(Round(z_x)-2,Round(z_y-2),Round(z_x)+7,Round(z_y)+7,1);
      C.SetForeColor(0,0,0);
  END;

(*###################Schlange1##################################*)
                    IF multi=TRUE THEN
(*###################Schlange2##################################*)

  IF (*berprft, ob der kopf der schlange auf ein futter-quadrat trifft*)
      (
      (Round(Snake2.aktX  + 1 * Float.Cos(Bogen(Snake2.winkel))) >= Round(z_x)-3)
      &
      (Round(Snake2.aktX  + 1 * Float.Cos(Bogen(Snake2.winkel))) <= Round(z_x)+8) 
      &
      (Round(Snake2.aktY  + 1 * Float.Cos(Bogen(Snake2.winkel)))>=Round(z_y)-3)
      & 
      (Round(Snake2.aktY  + 1 * Float.Cos(Bogen(Snake2.winkel)))<=Round(z_y)+8)
      )
      OR
      (
      (Round(Snake2.aktX+2  + 1 * Float.Cos(Bogen(Snake2.winkel))) >= Round(z_x)-3)
      &
      (Round(Snake2.aktX+2  + 1 * Float.Cos(Bogen(Snake2.winkel))) <= Round(z_x)+8) 
      &           
      (Round(Snake2.aktY+2  + 1 * Float.Cos(Bogen(Snake2.winkel)))>=Round(z_y)-3)
      & 
      (Round(Snake2.aktY+2  + 1 * Float.Cos(Bogen(Snake2.winkel)))<=Round(z_y)+8)
      )
      OR
      (
      (Round(Snake2.aktX-2  + 1 * Float.Cos(Bogen(Snake2.winkel))) >= Round(z_x)-3)
      &
      (Round(Snake2.aktX-2  + 1 * Float.Cos(Bogen(Snake2.winkel))) <= Round(z_x)+8) 
      &
      (Round(Snake2.aktY-2  + 1 * Float.Cos(Bogen(Snake2.winkel)))>=Round(z_y)-3)
      & 
      (Round(Snake2.aktY-2  + 1 * Float.Cos(Bogen(Snake2.winkel)))<=Round(z_y)+8)
      )
  THEN
      (*wenn ja, dann wird es 'gefressen'*)
      neue_box:=TRUE;
      INC(wahre_laenge2,25);

      C.SetForeColor(255,255,255);
      C.Box(Round(z_x),Round(z_y),Round(z_x)+5,Round(z_y)+5,1);
      C.Box(Round(z_x)+1,Round(z_y)+1,Round(z_x)+4,Round(z_y)+4,1);
      C.Box(Round(z_x)+2,Round(z_y)+2,Round(z_x)+3,Round(z_y)+3,1);
      C.Box(Round(z_x)-1,Round(z_y-1),Round(z_x)+6,Round(z_y)+6,1);
      C.Box(Round(z_x)-2,Round(z_y-2),Round(z_x)+7,Round(z_y)+7,1);
      C.SetForeColor(0,0,0);
      TerminalBell();TerminalBell();
      punkte_add2:=Punkte_add(menu_set_V);
  ELSE 
      (*ansonsten nicht*)
      neue_box:=FALSE;
      C.SetForeColor(255,0,0);
      C.Box(Round(z_x),Round(z_y),Round(z_x)+5,Round(z_y)+5,1);
      C.Box(Round(z_x)+1,Round(z_y)+1,Round(z_x)+4,Round(z_y)+4,1);
      C.Box(Round(z_x)+2,Round(z_y)+2,Round(z_x)+3,Round(z_y)+3,1);
      C.Box(Round(z_x)-1,Round(z_y-1),Round(z_x)+6,Round(z_y)+6,1);
      C.Box(Round(z_x)-2,Round(z_y-2),Round(z_x)+7,Round(z_y)+7,1);
      C.SetForeColor(0,0,0);
  END;

(*###################Schlange2##################################*)
                    ELSE END;

(*###################Schlange1##################################*) 
   (*die neuen koordinatend er schlange werden nun zu ihren 'alten'*)
  Snake1.aktX := neuX1;
  Snake1.aktY := neuY1;

(*###################Schlange1##################################*)

                     IF multi=TRUE THEN
(*###################Schlange2##################################*) 
  (*die neuen koordinatend er schlange werden nun zu ihren 'alten'*)
  Snake2.aktX := neuX2;
  Snake2.aktY := neuY2;

(*###################Schlange2##################################*)
                    ELSE END;


  (*punkte werden berechnet, aber nur wenn was gerfessen wurde*) 
  punkte1:=punkte1+punkte_add1;
  punkte2:=punkte2+punkte_add2;
  punkte_add1:=0;punkte_add2:=0;
  (*Punkte werden ausgegeben*)
  print_punkte(punkte1,punkte2); 
  (* wenn man gestorben ist, wird man hier aus dme programmablauf geworfen*)  

(*###################Schlange1##################################*)  
IF tot1=TRUE THEN EXIT END; 
(*###################Schlange1##################################*)
                      IF multi=TRUE THEN
(*###################Schlange2##################################*)  
IF tot2=TRUE THEN EXIT END; 
(*###################Schlange2##################################*)
                    ELSE END;

  (*wenn man bis hier her gekommen ist, beginnt wieder alles von vorn*)
END;

  (*beileid*)
  C.GotoXY(260,550);
  C.SetForeColor(255,0,0);
  C.WriteStr('Game Over!');
  C.SetForeColor(0,0,0);
  taste1:=C.ReadKey();



 
END;
C.Close;  (*und tschss*)
END ProgMain;
END Snake.
