MODULE BRAUNsche_Roehre;
IMPORT winuser,F:=Float,C:=ColorPlane;

CONST
  l=0.04;
  d=0.02;
  s=0.10;
  e=1.602177E-19;
  m=9.1093897E-31;
  c=2.99792458E8;
  Pi=3.14159265359;
  weg_zum_schirm=300;
VAR
  a_U,y_U:LONGREAL;
  y_U_str,a_U_str:ARRAY 15 OF CHAR;

(*############################################*)

PROCEDURE ClrScr;
VAR
BEGIN
  C.SetForeColor(255,255,255);
  C.Bar(0,0,800,650,1);
  C.GotoXY(0,650);
  C.SetForeColor(0,0,0);
END ClrScr;

(*#############################################*)

PROCEDURE Bogen(grad:LONGREAL):LONGREAL;
    (* rechnet Gradzahlen in Bogenma um *)
  BEGIN
    RETURN grad / 180 * SHORT(F.Pi);
END Bogen;

(*#############################################*)

PROCEDURE beschriftung;
VAR
BEGIN
    
  C.GotoXY(16,150);
  C.WriteStr('U');
  
  C.GotoXY(10,165);
  C.WriteStr('-+');
  
  C.Line(5,280,5,150,1);
  C.Line(36,220,36,150,1);
  C.Line(5,150,15,150,1);
      C.Dot(15,151,1);C.Dot(16,151,1);
      C.Dot(15,149,1);C.Dot(16,150,1);
      C.Dot(16,149,1);                     (*Beschleunigungsspannung*)
  C.Line(36,150,26,150,1);
      C.Dot(26,151,1);C.Dot(25,151,1);
      C.Dot(26,149,1);C.Dot(25,150,1);
      C.Dot(25,149,1);
      


   C.Line(186,320,186,360,1);
   C.Line(186,360,120,360,1);
   C.Line(120,360,120,340,1);
   C.Line(120,200,120,150,1);
   C.Line(186,220,186,150,1);
   C.Line(120,150,140,150,1);
      C.Dot(140,151,1);C.Dot(141,151,1);
      C.Dot(140,149,1);C.Dot(141,150,1);
      C.Dot(141,149,1);                     (*Ablenkspannung*)
   C.Line(186,150,166,150,1);
      C.Dot(165,151,1);C.Dot(165,151,1);
      C.Dot(165,149,1);C.Dot(165,150,1);
      C.Dot(164,149,1);
   C.GotoXY(148,150);
   C.WriteStr('U');
   C.GotoXY(144,167);
   C.WriteStr('+-');

END beschriftung;

(*#############################################*)

PROCEDURE graph(a_U,y_U:LONGREAL; v0:LONGREAL);
VAR
  laenge,x,dot_x,dot_y,ausgangs_x,ausgangs_y,ziel_y:INTEGER;
  y,alpha,y_treffer_schirm:LONGREAL;
BEGIN
  
  laenge:=0;
  x:=0;
  y:=0;                                             (*Graph im Kondensator*)
  WHILE laenge<133 DO
    INC(x);
    y:=((e*y_U*laenge*laenge)/(2*m*d*v0*v0));
    dot_x:=120+x;
    dot_y:=270+SHORT(ENTIER(y/2150));
    C.Dot(dot_x,dot_y,1);
    laenge:=laenge+1;
    IF (dot_y<224) OR (dot_y>317) THEN laenge:=133;
    ELSE END;
  END;

  
  
  IF (dot_y>224) & (dot_y<318) THEN 
  ausgangs_x:= dot_x;ausgangs_y:= dot_y;
  
  alpha:=F.ArcTanL((e*y_U*l)/(m*d*v0*v0)*1.5);        (*Graph hinter dem Kondensator*)
  
  y_treffer_schirm:=weg_zum_schirm*F.TanL(alpha)+ausgangs_y;
  ziel_y:=SHORT(ENTIER(y_treffer_schirm));
  C.Line(ausgangs_x,ausgangs_y,ausgangs_x+331,ziel_y,1);
  ELSE
  END;

END graph;

(*#############################################*)

PROCEDURE graph_w(a_U,y_U:LONGREAL; v0:LONGREAL);
VAR
  laenge,x,dot_x,dot_y,ausgangs_x,ausgangs_y,ziel_y:INTEGER;
  y,alpha,y_treffer_schirm:LONGREAL;
BEGIN
  
  laenge:=0;
  x:=0;
  y:=0;                                             (*Graph im Kondensator*)
  WHILE laenge<133 DO
    INC(x);
    y:=((e*y_U*laenge*laenge)/(2*m*d*v0*v0));
    dot_x:=120+x;
    dot_y:=270+SHORT(ENTIER(y/2150));

    C.Dot(dot_x,dot_y,1);
    laenge:=laenge+1;
    IF (dot_y<224) OR (dot_y>317) THEN laenge:=133;
    ELSE END;
  END;

  
  
  IF (dot_y>224) & (dot_y<318) THEN 
  ausgangs_x:= dot_x;ausgangs_y:= dot_y;
  
  alpha:=F.ArcTanL((e*y_U*l)/(m*d*v0*v0)*1.5);        (*Graph hinter dem Kondensator*)
  
  y_treffer_schirm:=weg_zum_schirm*F.TanL(alpha)+ausgangs_y;
  ziel_y:=SHORT(ENTIER(y_treffer_schirm));
  C.Line(ausgangs_x,ausgangs_y,ausgangs_x+331,ziel_y,1);
  ELSE
  END;

END graph_w;

(*#############################################*)

PROCEDURE test(a_U,y_U:LONGREAL);
VAR
  v0,
  y1,
  y1_cm,
  y_ges,y_ges_cm,
  laenge,
  y,
  alpha,
  y_treffer_schirm,v_c:LONGREAL;
  v0_text,y1_text,y_ges_text,v_c_text:ARRAY 15 OF CHAR;
  x,dot_x,dot_y,
  ausgangs_x,ausgangs_y,ziel_y,o1,p1,i1:INTEGER;
  key:CHAR;
  ende:BOOLEAN;
  x1,q,w,punkt_x,punkt_y:REAL;

BEGIN
  a_U:=a_U*1000;
  
  ClrScr;  
  

  C.SetForeColor(0,0,0);
  
  
  C.Line(586,0,576,0,1);  C.Line(586,550,576,550,1);
  C.Line(586,1,576,1,1);  C.Line(586,551,576,551,1);
  C.Line(576,550,253,340,1); C.Line(576,0,253,200,1);      (*Gehuse der Rhre*)
  C.Line(576,551,253,341,1); C.Line(576,1,253,201,1);
  C.Line(253,200,0,200,1); C.Line(253,201,0,201,1);
  C.Line(253,340,0,340,1); C.Line(253,341,0,341,1);
  
  C.SetForeColor(250,0,0);
  C.Bar(0,280,10,258,1); (*Elektronenquelle*)
  C.SetForeColor(0,0,0);
  
  C.Bar(35,320,36,275,1);
  C.Bar(35,265,36,220,1); (*Beschleunigungs Anode*);
  
  C.Bar(120,320,253,321,1);(*Kondensator*)
  C.Bar(120,220,253,221,1);(*Ablenkplatten*)
  
  C.Bar(586,0,587,550,1);   (*Schirm*)
 

  C.Line(586,500,590,500,1);
  C.Line(586,454,590,454,1);
  C.Line(586,408,590,408,1);
  C.Line(586,361,590,361,1);
  C.Line(586,316,590,316,1);
  C.Line(586,270,595,270,1);(*Skala*)
  C.Line(586,225,590,225,1);
  C.Line(586,178,590,178,1);
  C.Line(586,132,590,132,1);
  C.Line(586,084,590,084,1);
  C.Line(586,038,590,038,1);
  
  beschriftung;    
      
  
  C.SetForeColor(0,0,255);
  C.Line(10,270,120,270,1);  (*Elektronenstrahl*)


  
  LOOP
  C.SetForeColor(0,0,0);  
  
  v0:=F.SqrtL(c*c-c*c*((m*c*c)/(e*a_U+m*c*c))*((m*c*c)/(e*a_U+m*c*c)));
  v_c:=v0/c;
  F.StrF(v_c,1,10,v_c_text);
  F.StrF(v0,10,2,v0_text);
  C.GotoXY(0,650);C.WriteStr('Anfangsgeschwindigkeit: ');C.WriteStr(v0_text);C.WriteStr(' m/s');
  C.WriteStr(' (');C.WriteStr(v_c_text);C.WriteStr(' c)');
  
  y1:=((e*y_U*l*l)/(2*m*d*v0*v0));
  y1_cm:=y1*100;
  F.StrF(y1_cm,2,2,y1_text);
  C.GotoXY(0,630);C.WriteStr('Ablenkung im Kondensator um ');C.WriteStr(y1_text);C.WriteStr(' cm');

  y_ges:=((e*y_U*l)/(m*d*v0*v0)*(l+s))-((e*y_U*l*l)/(2*m*d*v0*v0));
  y_ges_cm:=y_ges*100;
  F.StrF(y_ges_cm,3,2,y_ges_text);  
  C.GotoXY(0,610);C.WriteStr('Ablenkung auf dem Schirm: ');C.WriteStr(y_ges_text);C.WriteStr(' cm');

  F.StrF(a_U,10,2,a_U_str);
  F.StrF(y_U,10,2,y_U_str);
  C.GotoXY(0,590);C.WriteStr('Beschleunigungsspannung: ');C.WriteStr(a_U_str); C.WriteStr(' V');C.WriteStr(' Cursor Left/Right');C.WriteLn;
  C.GotoXY(0,570);C.WriteStr('Ablenkspannung         : ');C.WriteStr(y_U_str); C.WriteStr(' V');C.WriteStr(' Cursor Up/Down');C.WriteLn;
  
  C.SetForeColor(0,0,255);
  graph(a_U,y_U,v0);
  

  
  key:=C.ReadKey();
  
  C.SetForeColor(255,255,255);
  graph_w(a_U,y_U,v0);
  C.SetForeColor(0,0,255);
  
  CASE key OF
     C.CURSUP   :y_U:=y_U+10;
    |C.CURSDOWN :y_U:=y_U-10;
    |C.CURSLEFT :
        IF a_U<501 THEN a_U:=a_U-100 ELSIF a_U<101 THEN a_U:=a_U-10 ELSIF a_U<11 THEN a_U:=a_U-1 ELSE a_U:=a_U-500; END;
        IF a_U<1 THEN a_U:=1;ELSE END;
    |C.CURSRIGHT:                            (*Menfunktion*)
        IF a_U<10 THEN a_U:=a_U+1 ELSIF a_U<100 THEN a_U:=a_U+10 ELSIF a_U<500 THEN a_U:=a_U+100 ELSE a_U:=a_U+500; END;
    |C.PAGEUP:  a_U:=a_U+100000;
    |C.PAGEDOWN:a_U:=a_U-100000; IF a_U<0 THEN a_U:=1 ELSE END;      
    |C.HOME:    y_U:=y_U+1000;
    |C.ENDKEY:     y_U:=y_U-1000;
    |C.ESC      :ende:=TRUE;
  ELSE
  END;



  IF ende=TRUE THEN EXIT END;
        (*Ende*)
  END;
  
END test;

(*#############################################*)

PROCEDURE konfig;
VAR
  resCode:CHAR;

BEGIN
  ClrScr;
  C.WriteStr('Schirmdurchmesser: 10 cm');C.WriteLn;
  C.WriteStr('Lnge des Kondensators: 4 cm');C.WriteLn;
  C.WriteStr('Abstand der Kondensatorplatten: 2 cm');C.WriteLn;
  C.WriteStr('Weg von der Kante des Kondensators zum Schirm: 10 cm');C.WriteLn;
  C.WriteStr('Beschleunigungsspannung der Katode (kV): ');C.ReadStr(a_U_str,6,resCode);C.WriteLn;
  C.WriteStr('Ablenkspannung des Kondensators (V): ');C.ReadStr(y_U_str,6,resCode);C.WriteLn;
  C.WriteLn;
  a_U:=F.Val(a_U_str);
  y_U:=F.Val(y_U_str);
  
  test(a_U,y_U); 
  
END konfig;

(*#############################################*)

PROCEDURE ProgMain*;
VAR
  menu:CHAR;
BEGIN
  C.Open;
  
  IF winuser.ShowWindow(winuser.GetActiveWindow(),3) = 0
      THEN
         C.SetForeColor(255,0,0);
         C.GotoXY(580,40);
         C.WriteStr('Fehler im Modul WinUser!')
  END;
  
  
  LOOP
  ClrScr;
  C.WriteStr('Ablenkung eines Elektronenstrahls in der BRAUNschen Rhre');C.WriteLn;
  C.WriteStr('');C.WriteLn;
  C.WriteLn;
  C.WriteStr('Dieses Programm kan ihnen den Verlauf eines Elektronenstrahls innerhalb einer');C.WriteLn;
  C.WriteStr('BRAUNschen Rhre graphisch darstellen.');C.WriteLn;C.WriteLn;
  C.WriteStr('Drcken Sie [Enter], um den Versuch zu starten oder ');C.WriteLn;
  C.WriteStr('[Esc] um das Programm zu beenden.');C.WriteLn;

  menu:=C.ReadKey();
  IF menu=C.ENTER THEN konfig
  ELSIF menu=C.ESC THEN EXIT
  ELSE
  END;
  END; 
  C.Close;
END ProgMain;
END BRAUNsche_Roehre.
