(***********************************************************************************************************************)
(*Problem:                                                                                                             *)
(*    Scheiben unterschiedlicher Gren sitzen von unten nach oben, beginnend mit der Grten, auf einem Stab.         *)
(*    Ziel ist es, mit Hilfe eines eines dritten Stabes den Turm aus den Scheiben Stck fr Stck auf einen            *)
(*    anderen umzustapeln, ohne dass dabei eine grere Scheibe auf einer Kleineren sitzt.                             *)
(*                                                                                                                     *)
(*                                                                                                                     *)
(*                                                                                                                     *)
(*                                                                                                                     *)
(*                                                                                                                     *)
(***********************************************************************************************************************)

 MODULE Hanoi;

 IMPORT C:=ColorPlane,D:=Display,F:=Float,U:=Utils;                    

 CONST  start='A';
        ziel ='B';
        hilf ='C';

 VAR    r,h,hA,hB,hC,i,j,anzahl,sec,min,hour,
        sec2,min2,hour2                           :INTEGER;
        taste,dummyChar                           :CHAR;
        end,ani                                   :BOOLEAN;
        animation                                 :ARRAY 4 OF CHAR;
        z,p                                       :LONGINT;
        q                                         :REAL;
    
(***********************************************************************************************************************)
(**)PROCEDURE Menu;                                                                                                  (**)
(**)  (***********************************************************************************************************)  (**)
(**)  (**)PROCEDURE Start;                                                                                     (**)  (**)
(**)  (**)  (***********************************************************************************************)  (**)  (**)
(**)  (**)  (**)PROCEDURE Turm(scheibe:INTEGER;von,nach,hi:CHAR);                                        (**)  (**)  (**)
(**)  (**)  (**)BEGIN                                                                                    (**)  (**)  (**)
(**)  (**)  (**)  IF scheibe>0 THEN                                                                      (**)  (**)  (**)
(**)  (**)  (**)    Turm(scheibe-1,von,hi,nach);                                                         (**)  (**)  (**)
(**)  (**)  (**)    D.WriteStr('Scheibe '); D.WriteInt(scheibe,3); D.WriteStr(' von ');                  (**)  (**)  (**)
(**)  (**)  (**)    D.WriteChar(von); D.WriteStr(' nach '); D.WriteChar(nach); D.WriteLn;                (**)  (**)  (**)
(**)  (**)  (**)    INC(z);                                                                              (**)  (**)  (**)
(**)  (**)  (**)    IF D.KeyPressed()=TRUE THEN dummyChar:=D.ReadKey(); ELSE END;                        (**)  (**)  (**)
(**)  (**)  (**)    IF dummyChar=D.ESC THEN scheibe:=0 ELSE END;                                         (**)  (**)  (**)
(**)  (**)  (**)    Turm(scheibe-1,hi,nach,von);                                                         (**)  (**)  (**)
(**)  (**)  (**)  END;                                                                                   (**)  (**)  (**)
(**)  (**)  (**)END Turm;                                                                                (**)  (**)  (**)
(**)  (**)  (***********************************************************************************************)  (**)  (**)
(**)  (**)  (***********************************************************************************************)  (**)  (**)
(**)  (**)  (**)PROCEDURE AniStart;                                                                      (**)  (**)  (**)
(**)  (**)  (**)  (***********************************************************************************)  (**)  (**)  (**)
(**)  (**)  (**)  (**)PROCEDURE AniTurm(scheibe:INTEGER;von,nach,hi:CHAR);                         (**)  (**)  (**)  (**)
(**)  (**)  (**)  (**)BEGIN                                                                        (**)  (**)  (**)  (**)
(**)  (**)  (**)  (**)  IF scheibe>0 THEN                                                          (**)  (**)  (**)  (**)
(**)  (**)  (**)  (**)    AniTurm(scheibe-1,von,hi,nach);                                          (**)  (**)  (**)  (**)
(**)  (**)  (**)  (**)    FOR i:=1 TO p*100 DO                                                     (**)  (**)  (**)  (**)
(**)  (**)  (**)  (**)      FOR j:=1 TO p*10 DO                                                    (**)  (**)  (**)  (**)
(**)  (**)  (**)  (**)        q:=F.Sqrt(9);                                                        (**)  (**)  (**)  (**)
(**)  (**)  (**)  (**)      END;                                                                   (**)  (**)  (**)  (**)
(**)  (**)  (**)  (**)    END;                                                                     (**)  (**)  (**)  (**)
(**)  (**)  (**)  (**)    D.WriteInt(scheibe,3); D.WriteChar(von); D.WriteChar(nach);              (**)  (**)  (**)  (**)
(**)  (**)  (**)  (**)    IF z+1 MOD 5=0 THEN D.WriteLn                                            (**)  (**)  (**)  (**)
(**)  (**)  (**)  (**)    ELSE D.WriteStr('   ') END;                                              (**)  (**)  (**)  (**)
(**)  (**)  (**)  (**)    C.SetForeColor(255,255,255); C.SetBackColor(255,255,255);                (**)  (**)  (**)  (**)
(**)  (**)  (**)  (**)    CASE von OF                                                              (**)  (**)  (**)  (**)
(**)  (**)  (**)  (**)       'A': C.Bar( 73,hA-h,223,hA,1);                                        (**)  (**)  (**)  (**)
(**)  (**)  (**)  (**)            C.SetForeColor(0,0,0); C.SetBackColor(0,0,0);                    (**)  (**)  (**)  (**)
(**)  (**)  (**)  (**)            C.Bar(146,hA-h,150,hA,1); hA:=hA-h;                              (**)  (**)  (**)  (**)
(**)  (**)  (**)  (**)      |'B': C.Bar(225,hB-h,375,hB,1);                                        (**)  (**)  (**)  (**)
(**)  (**)  (**)  (**)            C.SetForeColor(0,0,0); C.SetBackColor(0,0,0);                    (**)  (**)  (**)  (**)
(**)  (**)  (**)  (**)            C.Bar(298,hB-h,302,hB,1); hB:=hB-h;                              (**)  (**)  (**)  (**)
(**)  (**)  (**)  (**)      |'C': C.Bar(371,hC-h,521,hC,1);                                        (**)  (**)  (**)  (**)
(**)  (**)  (**)  (**)            C.SetForeColor(0,0,0); C.SetBackColor(0,0,0);                    (**)  (**)  (**)  (**)
(**)  (**)  (**)  (**)            C.Bar(444,hC-h,448,hC,1); hC:=hC-h;                              (**)  (**)  (**)  (**)
(**)  (**)  (**)  (**)      ELSE END;                                                              (**)  (**)  (**)  (**)
(**)  (**)  (**)  (**)    C.SetForeColor(200,scheibe*13,0); C.SetBackColor(200,scheibe*13,0);      (**)  (**)  (**)  (**)
(**)  (**)  (**)  (**)    CASE nach OF                                                             (**)  (**)  (**)  (**)
(**)  (**)  (**)  (**)       'A': C.Bar(140-((scheibe)*r),hA,156+((scheibe)*r),hA+h,1); hA:=hA+h;  (**)  (**)  (**)  (**)
(**)  (**)  (**)  (**)      |'B': C.Bar(292-((scheibe)*r),hB,308+((scheibe)*r),hB+h,1); hB:=hB+h;  (**)  (**)  (**)  (**)
(**)  (**)  (**)  (**)      |'C': C.Bar(438-((scheibe)*r),hC,454+((scheibe)*r),hC+h,1); hC:=hC+h;  (**)  (**)  (**)  (**)
(**)  (**)  (**)  (**)    ELSE END;                                                                (**)  (**)  (**)  (**)
(**)  (**)  (**)  (**)    C.SetForeColor(0,0,0); C.SetBackColor(0,0,0);                            (**)  (**)  (**)  (**)
(**)  (**)  (**)  (**)    INC(z);                                                                  (**)  (**)  (**)  (**)
(**)  (**)  (**)  (**)    IF D.KeyPressed()=TRUE THEN dummyChar:=D.ReadKey(); ELSE END;            (**)  (**)  (**)  (**)            
(**)  (**)  (**)  (**)    IF dummyChar=D.ESC THEN scheibe:=0; ELSE END;                            (**)  (**)  (**)  (**)               
(**)  (**)  (**)  (**)    AniTurm(scheibe-1,hi,nach,von);                                          (**)  (**)  (**)  (**)
(**)  (**)  (**)  (**)  END;                                                                       (**)  (**)  (**)  (**)
(**)  (**)  (**)  (**)END AniTurm;                                                                 (**)  (**)  (**)  (**)
(**)  (**)  (**)  (***********************************************************************************)  (**)  (**)  (**)
(**)  (**)  (**)BEGIN                                                                                    (**)  (**)  (**)
(**)  (**)  (**)  C.Open;                                                                                (**)  (**)  (**)
(**)  (**)  (**)  h:=0;                                                                                  (**)  (**)  (**)
(**)  (**)  (**)  FOR i:=1 TO (20/anzahl) DO INC(h) END;                                                 (**)  (**)  (**)
(**)  (**)  (**)  r:=2*h; h:=h*9;                                                                        (**)  (**)  (**)
(**)  (**)  (**)  IF h>20 THEN h:=20 END;                                                                (**)  (**)  (**)
(**)  (**)  (**)  hA:=40; hB:=40; hC:=40;                                                                (**)  (**)  (**)
(**)  (**)  (**)  C.Bar( 10, 35,600, 39,1); C.Bar(146, 35,150,230,1);                                    (**)  (**)  (**)
(**)  (**)  (**)  C.Bar(298, 35,302,230,1); C.Bar(444, 35,448,230,1);                                    (**)  (**)  (**)
(**)  (**)  (**)  FOR i:=-anzahl TO -1 DO                                                                (**)  (**)  (**)
(**)  (**)  (**)    C.SetForeColor(200,-i*13,0); C.SetBackColor(200,-i*13,0);                            (**)  (**)  (**)
(**)  (**)  (**)    C.Bar(140+(i*r), hA, 156-(i*r), h+hA,1); hA:=hA+h;                                   (**)  (**)  (**)
(**)  (**)  (**)  END;                                                                                   (**)  (**)  (**)
(**)  (**)  (**)  AniTurm(anzahl,start,ziel,hilf);                                                       (**)  (**)  (**)
(**)  (**)  (**)  D.WriteLn;                                                                             (**)  (**)  (**)
(**)  (**)  (**)  IF z=1 THEN D.WriteStr('     1 Zug')                                                   (**)  (**)  (**)
(**)  (**)  (**)  ELSE D.WriteInt(z,6); D.WriteStr(' Zge') END;                                         (**)  (**)  (**)
(**)  (**)  (**)  D.WriteLn;                                                                             (**)  (**)  (**)
(**)  (**)  (**)  U.GetTime(sec, min, hour);                                                             (**)  (**)  (**)
(**)  (**)  (**)  sec:=sec-sec2;  min:=min-min2; hour:=hour-hour2;                                       (**)  (**)  (**)
(**)  (**)  (**)  D.WriteStr('Zeit (h:m:s): '); D.WriteInt(hour,1); D.WriteStr(':');                     (**)  (**)  (**)
(**)  (**)  (**)  D.WriteInt(min,2); D.WriteStr(':');                                                    (**)  (**)  (**)
(**)  (**)  (**)  D.WriteInt(sec,2);                                                                     (**)  (**)  (**)
(**)  (**)  (**)  REPEAT UNTIL D.KeyPressed();                                                           (**)  (**)  (**)
(**)  (**)  (**)  C.Close                                                                                (**)  (**)  (**)
(**)  (**)  (**)END AniStart;                                                                            (**)  (**)  (**)
(**)  (**)  (***********************************************************************************************)  (**)  (**)
(**)  (**)BEGIN                                                                                                (**)  (**)
(**)  (**)  D.ClrScr;                                                                                          (**)  (**)
(**)  (**)  U.GetTime(sec, min, hour);                                                                         (**)  (**)
(**)  (**)  sec2:=sec; min2:=min; hour2:=hour;                                                                 (**)  (**)
(**)  (**)  IF ani=TRUE THEN AniStart;                                                                         (**)  (**)
(**)  (**)  ELSE Turm(anzahl,start,ziel,hilf) END;                                                             (**)  (**)
(**)  (**)  D.WriteLn;                                                                                         (**)  (**)
(**)  (**)  IF z=1 THEN D.WriteStr('     1 Zug')                                                               (**)  (**)
(**)  (**)  ELSE D.WriteInt(z,6); D.WriteStr(' Zge') END;                                                     (**)  (**)
(**)  (**)  D.WriteLn;                                                                                         (**)  (**)
(**)  (**)  U.GetTime(sec, min, hour);                                                                         (**)  (**)
(**)  (**)  sec:=sec-sec2; min:=min-min2; hour:=hour-hour2;                                                    (**)  (**)
(**)  (**)  D.WriteStr('Zeit (h:m:s): '); D.WriteInt(hour,1); D.WriteStr(':');                                 (**)  (**)
(**)  (**)  D.WriteInt(min,2); D.WriteStr(':');                                                                (**)  (**)
(**)  (**)  D.WriteInt(sec,2);                                                                                 (**)  (**)
(**)  (**)  REPEAT UNTIL D.KeyPressed();                                                                       (**)  (**)
(**)  (**)  z:=0;                                                                                              (**)  (**)
(**)  (**)  D.FlushKeyBuffer();                                                                                (**)  (**)
(**)  (**)END Start;                                                                                           (**)  (**)
(**)  (***********************************************************************************************************)  (**)
(**)BEGIN                                                                                                            (**)
(**)  LOOP;                                                                                                          (**)
(**)    dummyChar:='a';                                                                                              (**)
(**)    D.ClrScr;                                                                                                    (**)
(**)    D.WriteStr('                             Der Turm von Hanoi'); D.WriteLn;                                    (**)
(**)    D.WriteStr('                             '); D.WriteLn;                                    (**)
(**)    D.WriteLn; D.WriteLn; D.WriteLn;                                                                             (**)
(**)    D.WriteStr('                                  Scheiben'); D.WriteLn;                                         (**)
(**)    D.WriteStr('                                 <  '); D.WriteInt(anzahl,3); D.WriteStr('   >');                (**)
(**)    D.WriteLn; D.WriteLn; D.WriteLn;                                                                             (**)
(**)    IF ani=TRUE THEN animation:=' AN'                                                                            (**)
(**)    ELSE animation:='AUS' END;                                                                                   (**)
(**)    D.WriteStr('                           Animation '); D.WriteStr(animation); D.WriteStr('     [F1]');         (**)
(**)    D.WriteLn; D.WriteLn;                                                                                        (**)
(**)    D.WriteStr('                                   Pause'); D.WriteLn;                                           (**)
(**)    D.WriteStr('                                 -  '); D.WriteInt(p,3); D.WriteStr('   +');                     (**)
(**)    D.WriteLn; D.WriteLn; D.WriteLn; D.WriteLn; D.WriteLn;                                                       (**)
(**)    D.WriteStr('                           Start          [Enter]'); D.WriteLn;                                  (**)
(**)    D.WriteStr('                           Beenden          [ESC]'); D.WriteLn;                                  (**)
(**)    taste:=D.ReadKey();                                                                                          (**)
(**)    CASE taste OF                                                                                                (**)
(**)       D.F1        : IF ani=TRUE THEN ani:=FALSE ELSE ani:=TRUE END;                                             (**)
(**)      |D.CURSLEFT  : anzahl:=anzahl-1; IF anzahl=0 THEN anzahl:=20 END;                                          (**)
(**)      |D.CURSRIGHT : anzahl:=anzahl+1; IF anzahl=21 THEN anzahl:=1 END;                                          (**)
(**)      |'+'         : p:=p+1; IF p=101 THEN p:=0 END;                                                             (**)
(**)      |'-'         : p:=p-1; IF p=-1 THEN p:=100 END;                                                            (**)
(**)      |D.ENTER     : Start;                                                                                      (**)
(**)      |D.ESC       : end:=TRUE;                                                                                  (**)
(**)      ELSE                                                                                                       (**)
(**)    END;                                                                                                         (**)
(**)    IF end=TRUE THEN EXIT END;                                                                                   (**)
(**)  END;                                                                                                           (**)
(**)END Menu;                                                                                                        (**)
(***********************************************************************************************************************)

 PROCEDURE ProgMain*;
 BEGIN
   p:=50;
   anzahl:=3;
   ani:=TRUE;
   Menu;  
 END ProgMain;
 END Hanoi.
